
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "CPU.h"


using namespace qmf::com::redhat::matahari;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  CPU::packageName  = string ("com.redhat.matahari");
string  CPU::className    = string ("cpu");
uint8_t CPU::md5Sum[16]   =
    {0x92,0x6f,0xb5,0xe0,0xea,0x17,0x6a,0xa9,0xa7,0x3e,0xf2,0x61,0x19,0x63,0x8b,0x3e};

CPU::CPU (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent) :
    ManagementObject(_core)
{
    host = _parent->GetManagementObject ()->getObjectId ();
    cpunum = 0;
    corenum = 0;
    numcores = 0;
    model = 0;
    family = 0;
    cpuid_lvl = 0;
    speed = 0.;
    cache = 0;
    vendor = "";
    flags = "";



}

CPU::~CPU ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void CPU::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void CPU::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putOctet       (0);           // No Superclass
    buf.putShort       (11); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "host");
    ft.setInt    (TYPE, TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Host that this cpu belongs to");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "cpunum");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "CPU # for this host");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "corenum");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Index of core within CPU");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "numcores");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Total # of cores for CPU");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "model");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Processor Model");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "family");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Processor Family");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "cpuid_lvl");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "CPU ID Level");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "speed");
    ft.setInt    (TYPE, TYPE_DOUBLE);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "MHz");
    ft.setString (DESC,   "CPU Speed");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "cache");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "kb");
    ft.setString (DESC,   "CPU Cache Size");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "vendor");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "CPU Vendor");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "flags");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "CPU Flags");
    buf.put (ft);


    // Statistics

    // Methods

}



void CPU::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    host.encode(buf);
    buf.putInt32(cpunum);
    buf.putInt32(corenum);
    buf.putInt32(numcores);
    buf.putInt32(model);
    buf.putInt32(family);
    buf.putInt32(cpuid_lvl);
    buf.putDouble(speed);
    buf.putInt32(cache);
    buf.putShortString(vendor);
    buf.putMediumString(flags);

}

void CPU::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics


}

void CPU::doMethod (string&, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
