
#ifndef _MANAGEMENT_CPU_
#define _MANAGEMENT_CPU_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace matahari {


class CPU : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    ::qpid::management::ObjectId host;
    int32_t cpunum;
    int32_t corenum;
    int32_t numcores;
    int32_t model;
    int32_t family;
    int32_t cpuid_lvl;
    double speed;
    int32_t cache;
    std::string vendor;
    std::string flags;

    // Statistics


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }

  public:

    CPU(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent);
    ~CPU();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void set_host (const ::qpid::management::ObjectId& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        host = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_host() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return host;
    }
    inline void set_cpunum (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        cpunum = val;
        configChanged = true;
    }
    inline int32_t get_cpunum() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return cpunum;
    }
    inline void set_corenum (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        corenum = val;
        configChanged = true;
    }
    inline int32_t get_corenum() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return corenum;
    }
    inline void set_numcores (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        numcores = val;
        configChanged = true;
    }
    inline int32_t get_numcores() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return numcores;
    }
    inline void set_model (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        model = val;
        configChanged = true;
    }
    inline int32_t get_model() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return model;
    }
    inline void set_family (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        family = val;
        configChanged = true;
    }
    inline int32_t get_family() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return family;
    }
    inline void set_cpuid_lvl (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        cpuid_lvl = val;
        configChanged = true;
    }
    inline int32_t get_cpuid_lvl() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return cpuid_lvl;
    }
    inline void set_speed (double val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        speed = val;
        configChanged = true;
    }
    inline double get_speed() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return speed;
    }
    inline void set_cache (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        cache = val;
        configChanged = true;
    }
    inline int32_t get_cache() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return cache;
    }
    inline void set_vendor (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        vendor = val;
        configChanged = true;
    }
    inline const std::string& get_vendor() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return vendor;
    }
    inline void set_flags (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        flags = val;
        configChanged = true;
    }
    inline const std::string& get_flags() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return flags;
    }

};

}}}}

#endif  /*!_MANAGEMENT_CPU_*/
