
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "NIC.h"
#include "ArgsNICIdentify_nic.h"


using namespace qmf::com::redhat::matahari;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  NIC::packageName  = string ("com.redhat.matahari");
string  NIC::className    = string ("nic");
uint8_t NIC::md5Sum[16]   =
    {0x88,0xeb,0x2b,0xb0,0xd1,0xc1,0x4f,0x6f,0xbc,0xc4,0x74,0xd,0x77,0x6b,0x3d,0x8d};

NIC::NIC (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent) :
    ManagementObject(_core)
{
    host = _parent->GetManagementObject ()->getObjectId ();
    macaddr = "";
    interface = "";
    ipaddr = "";
    netmask = "";
    broadcast = "";
    bandwidth = 0;



}

NIC::~NIC ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void NIC::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void NIC::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putOctet       (0);           // No Superclass
    buf.putShort       (7); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (1); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "host");
    ft.setInt    (TYPE, TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Host that this NIC belongs to");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "macaddr");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "MAC Address");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "interface");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Interface name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "ipaddr");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "IP Address");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "netmask");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Netmask");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "broadcast");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Broadcast");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "bandwidth");
    ft.setInt    (TYPE, TYPE_S32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Bandwidth");
    buf.put (ft);


    // Statistics

    // Methods
    ft.clear();
    ft.setString (NAME,     "identify_nic");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Physically Identify NIC");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "seconds");
    ft.setInt    (TYPE,    TYPE_S32);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "ret");
    ft.setInt    (TYPE,    TYPE_S32);
    ft.setString (DIR,     "O");
    buf.put (ft);


}



void NIC::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    host.encode(buf);
    buf.putShortString(macaddr);
    buf.putShortString(interface);
    buf.putShortString(ipaddr);
    buf.putShortString(netmask);
    buf.putShortString(broadcast);
    buf.putInt32(bandwidth);

}

void NIC::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics


}

void NIC::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "identify_nic") {
        ArgsNICIdentify_nic ioArgs;
        ioArgs.i_seconds = inBuf.getInt32();
        status = coreObject->ManagementMethod (METHOD_IDENTIFY_NIC, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putInt32(ioArgs.o_ret);
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
