
#ifndef _MANAGEMENT_NIC_
#define _MANAGEMENT_NIC_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace matahari {


class NIC : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    ::qpid::management::ObjectId host;
    std::string macaddr;
    std::string interface;
    std::string ipaddr;
    std::string netmask;
    std::string broadcast;
    int32_t bandwidth;

    // Statistics


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }

  public:

    NIC(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent);
    ~NIC();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_IDENTIFY_NIC = 1;

    // Accessor Methods
    inline void set_host (const ::qpid::management::ObjectId& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        host = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_host() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return host;
    }
    inline void set_macaddr (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        macaddr = val;
        configChanged = true;
    }
    inline const std::string& get_macaddr() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return macaddr;
    }
    inline void set_interface (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        interface = val;
        configChanged = true;
    }
    inline const std::string& get_interface() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return interface;
    }
    inline void set_ipaddr (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        ipaddr = val;
        configChanged = true;
    }
    inline const std::string& get_ipaddr() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return ipaddr;
    }
    inline void set_netmask (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        netmask = val;
        configChanged = true;
    }
    inline const std::string& get_netmask() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return netmask;
    }
    inline void set_broadcast (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        broadcast = val;
        configChanged = true;
    }
    inline const std::string& get_broadcast() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return broadcast;
    }
    inline void set_bandwidth (int32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        bandwidth = val;
        configChanged = true;
    }
    inline int32_t get_bandwidth() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return bandwidth;
    }

};

}}}}

#endif  /*!_MANAGEMENT_NIC_*/
